/* mnavr.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int mnavr_c(S_fp func, integer *m, integer *n, integer *nsig,
        real *eps, real *delta, integer *maxfn, integer *iopt, real *parm, 
        real *x, real *ssq, real *f, real *xjac, integer *ixjac, real *xjtj, 
        real *work, integer *infer, integer *ier)
{
    /* Initialized data */

    static real sig = 6.3f;
    static real ten = 10.f;
    static real huntw = 120.f;
    static real onep10 = 1e10f;
    static real ax = .1f;
    static real p01 = .01f;
    static real tenth = .1f;
    static real half = .5f;
    static real zero = 0.f;
    static real one = 1.f;
    static real onep5 = 1.5f;
    static real two = 2.f;

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2, r__3, r__4, r__5, r__6;
    doublereal d__1, d__2;

    /* Builtin functions */
    double pow_dd(doublereal *, doublereal *), pow_ri(real *, integer *), 
            sqrt(doublereal), r_lg10(real *);

    /* Local variables */
    static integer ijac, ifml;
    static real prec;
    static integer ifpl;
    static real xdif;
    static integer ifpu, iter;
    static real fosq;
    static integer ifml1, ifpl1;
    extern /* Subroutine */ int ash1r_c(real *, real *, real *, integer *,
            integer *, integer *);
    static real cons2, erl2x, g;
    static integer i__, j, k, l, ieval;
    static real xdabs, sqdif, xhold, dnorm;
    static integer izero, ibad1j, ical1i, ical1j, igrad1, ixbad1, irad1i;
    static real delta2;
    static integer iscal1, ifml1i, ifpl1i, idelx1, ielx1i, ielx1j, inew1j, 
            ixnew1;
    static real al, fosqs4, hh;
    static integer ki, li, im;
    static real fo;
    static integer ir, is, js, igradl;
    static real up;
    static integer iscall, igradu, iscalu, idelxl;
    static real relcon, onesfo;
    static integer idelxu, icount;
    static real ssqold;
    static integer ixnewl;
    static real rel;
    static integer iri;
    static real rhh, dsq;
    static integer isw;
    static real sum, erl2;
    static integer ibad;

    /* Parameter adjustments */
    --f;
    --x;
    --parm;
    --xjac;
    --xjtj;
    --work;

    /* Function Body */
    *ier = 0;
    if (*m <= 0 || *n <= 0 || *iopt < 0 || *iopt > 2) {
        goto L620;
    }
    if (*iopt != 2) {
        goto L10;
    }
    if (parm[2] <= one || parm[1] <= zero) {
        goto L620;
    }
L10:
    d__1 = (doublereal) ten;
    d__2 = (doublereal) (-sig - one);
    prec = (real)pow_dd(&d__1, &d__2);
    d__1 = (doublereal) ten;
    d__2 = (doublereal) (-sig * half);
    rel = (real)pow_dd(&d__1, &d__2);
    i__1 = -(*nsig);
    relcon = (real)pow_ri(&ten, &i__1);
    igrad1 = (*n + 1) * *n / 2;
    igradl = igrad1 + 1;
    igradu = igrad1 + *n;
    idelx1 = igradu;
    idelxl = idelx1 + 1;
    idelxu = idelx1 + *n;
    iscal1 = idelxu;
    iscall = iscal1 + 1;
    iscalu = iscal1 + *n;
    ixnew1 = iscalu;
    ixnewl = ixnew1 + 1;
    ixbad1 = ixnew1 + *n;
    ifpl1 = ixbad1 + *n;
    ifpl = ifpl1 + 1;
    ifpu = ifpl1 + *m;
    ifml1 = ifpu;
    ifml = ifml1 + 1;
    al = one;
    cons2 = tenth;
    if (*iopt == 0) {
        goto L40;
    }
    if (*iopt == 1) {
        goto L20;
    }
    al = parm[1];
    fo = parm[2];
    up = parm[3];
    cons2 = parm[4] * half;
    goto L30;
L20:
    al = p01;
    fo = two;
    up = huntw;
L30:
    onesfo = one / fo;
    fosq = fo * fo;
/* Computing 4th power */
    r__1 = fosq, r__1 *= r__1;
    fosqs4 = r__1 * r__1;
L40:
    ieval = 0;
    delta2 = *delta * half;
    erl2 = onep10;
    ibad = -99;
    isw = 1;
    iter = -1;
    *infer = 0;
    *ier = 0;
    i__1 = idelxu;
    for (j = idelxl; j <= i__1; ++j) {
        work[j] = zero;
/* L50: */
    }
    goto L340;
L60:
    ssqold = *ssq;
    if (*infer > 0 || ijac >= *n || *iopt == 0 || icount > 0) {
        goto L110;
    }
    ++ijac;
    dsq = zero;
    i__1 = idelxu;
    for (j = idelxl; j <= i__1; ++j) {
        dsq += work[j] * work[j];
/* L70: */
    }
    if (dsq <= zero) {
        goto L110;
    }
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ifml1i = ifml1 + i__;
        g = f[i__] - work[ifml1i];
        k = i__;
        i__2 = idelxu;
        for (j = idelxl; j <= i__2; ++j) {
            g += xjac[k] * work[j];
            k += *m;
/* L80: */
        }
        g /= dsq;
        k = i__;
        i__2 = idelxu;
        for (j = idelxl; j <= i__2; ++j) {
            xjac[k] -= g * work[j];
            k += *m;
/* L90: */
        }
/* L100: */
    }
    goto L160;
L110:
    ijac = 0;
    k = 0;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        xdabs = (r__1 = x[j], abs(r__1));
        hh = rel * max(xdabs,ax);
        xhold = x[j];
        x[j] += hh;
        (*func)(&x[1], m, n, &work[ifpl]);
        ++ieval;
        x[j] = xhold;
        if (isw == 1) {
            goto L130;
        }
        x[j] = xhold - hh;
        (*func)(&x[1], m, n, &work[ifml]);
        ++ieval;
        x[j] = xhold;
        rhh = half / hh;
        i__2 = ifpu;
        for (i__ = ifpl; i__ <= i__2; ++i__) {
            ++k;
            im = i__ + *m;
            xjac[k] = (work[i__] - work[im]) * rhh;
/* L120: */
        }
        goto L150;
L130:
        rhh = one / hh;
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ++k;
            ifpl1i = ifpl1 + i__;
            xjac[k] = (work[ifpl1i] - f[i__]) * rhh;
/* L140: */
        }
L150:
        ;
    }
L160:
    erl2x = erl2;
    erl2 = zero;
    k = 0;
    i__1 = igradu;
    for (j = igradl; j <= i__1; ++j) {
        sum = zero;
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ++k;
            sum += xjac[k] * f[i__];
/* L170: */
        }
        work[j] = sum;
        erl2 += sum * sum;
/* L180: */
    }
    erl2 = (real)sqrt(erl2);
    if (ijac > 0) {
        goto L190;
    }
    if (erl2 <= delta2) {
        *infer += 4;
    }
    if (erl2 <= cons2) {
        isw = 2;
    }
L190:
    l = 0;
    is = -(*m);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        is += *m;
        js = 0;
        i__2 = i__;
        for (j = 1; j <= i__2; ++j) {
            ++l;
            sum = zero;
            i__3 = *m;
            for (k = 1; k <= i__3; ++k) {
                li = is + k;
                ++js;
                sum += xjac[li] * xjac[js];
/* L200: */
            }
            xjtj[l] = sum;
/* L210: */
        }
/* L220: */
    }
    if (*infer > 0) {
        goto L640;
    }
    if (ieval >= *maxfn) {
        goto L590;
    }
    if (*iopt == 0) {
        goto L240;
    }
    k = 0;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        k += j;
        ical1j = iscal1 + j;
        work[ical1j] = xjtj[k];
/* L230: */
    }
    goto L270;
L240:
    dnorm = zero;
    k = 0;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        k += j;
        ical1j = iscal1 + j;
        work[ical1j] = (real)sqrt(xjtj[k]);
        dnorm += xjtj[k] * xjtj[k];
/* L250: */
    }
    dnorm = one / (real)sqrt(dnorm);
    i__1 = iscalu;
    for (j = iscall; j <= i__1; ++j) {
        work[j] = work[j] * dnorm * erl2;
/* L260: */
    }
L270:
    icount = 0;
L280:
    k = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i__2 = i__;
        for (j = 1; j <= i__2; ++j) {
            ++k;
            work[k] = xjtj[k];
/* L290: */
        }
        ical1i = iscal1 + i__;
        work[k] += work[ical1i] * al;
        ielx1i = idelx1 + i__;
        irad1i = igrad1 + i__;
        work[ielx1i] = work[irad1i];
/* L300: */
    }
L310:
    ash1r_c(&work[1], &work[idelxl], &work[ixnewl], n, &c__1, ier);
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        ielx1j = idelx1 + j;
        inew1j = ixnew1 + j;
        work[ielx1j] = work[inew1j];
/* L320: */
    }
    if (*ier == 0) {
        goto L330;
    }
    *ier = 0;
    if (ijac > 0) {
        goto L110;
    }
    if (ibad <= 0) {
        goto L490;
    }
    if (ibad >= 2) {
        goto L630;
    }
    goto L390;
L330:
    if (ibad != -99) {
        ibad = 0;
    }
L340:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        ielx1j = idelx1 + j;
        inew1j = ixnew1 + j;
        work[inew1j] = x[j] - work[ielx1j];
/* L350: */
    }
    (*func)(&work[ixnewl], m, n, &work[ifpl]);
    ++ieval;
    *ssq = zero;
    i__1 = ifpu;
    for (i__ = ifpl; i__ <= i__1; ++i__) {
        *ssq += work[i__] * work[i__];
/* L360: */
    }
    if (iter >= 0) {
        goto L380;
    }
    iter = 0;
    ssqold = *ssq;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ifpl1i = ifpl1 + i__;
        f[i__] = work[ifpl1i];
/* L370: */
    }
    goto L110;
L380:
    if (*iopt == 0) {
        goto L440;
    }
    if (*ssq <= ssqold) {
        goto L420;
    }
L390:
    ++icount;
    al *= fosq;
    if (ijac == 0) {
        goto L400;
    }
    if (icount >= 4 || al > up) {
        goto L410;
    }
L400:
    if (al <= up) {
        goto L280;
    }
    if (ibad == 1) {
        goto L630;
    }
    goto L610;
L410:
    al /= fosqs4;
    goto L110;
L420:
    if (icount == 0) {
        al /= fo;
    }
    if (erl2x <= zero) {
        goto L430;
    }
    g = erl2 / erl2x;
    if (erl2 < erl2x) {
        al *= max(onesfo,g);
    }
    if (erl2 > erl2x) {
        al *= min(fo,g);
    }
L430:
    al = max(al,prec);
L440:
    ++iter;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        inew1j = ixnew1 + j;
        x[j] = work[inew1j];
/* L450: */
    }
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ifml1i = ifml1 + i__;
        work[ifml1i] = f[i__];
        ifpl1i = ifpl1 + i__;
        f[i__] = work[ifpl1i];
/* L460: */
    }
    if (icount > 0 || ijac > 0) {
        goto L60;
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        ielx1j = idelx1 + j;
/* Computing MAX */
        r__3 = (r__2 = x[j], abs(r__2));
        xdif = (r__1 = work[ielx1j], abs(r__1)) / max(r__3,ax);
        if (xdif > relcon) {
            goto L480;
        }
/* L470: */
    }
    *infer = 1;
L480:
    sqdif = (r__1 = *ssq - ssqold, abs(r__1)) / max(ssqold,ax);
    if (sqdif <= *eps) {
        *infer += 2;
    }
    goto L60;
L490:
    if (ibad < 0) {
        goto L520;
    } else if (ibad == 0) {
        goto L500;
    } else {
        goto L540;
    }
L500:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        ibad1j = ixbad1 + j;
        xhold = work[ibad1j];
/* Computing MAX */
        r__2 = ax, r__3 = abs(xhold);
        if ((r__1 = x[j] - xhold, abs(r__1)) > relcon * max(r__2,r__3)) {
            goto L520;
        }
/* L510: */
    }
    goto L600;
L520:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        ibad1j = ixbad1 + j;
        work[ibad1j] = x[j];
/* L530: */
    }
    ibad = 1;
L540:
    if (*iopt != 0) {
        goto L570;
    }
    k = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i__2 = i__;
        for (j = 1; j <= i__2; ++j) {
            ++k;
            work[k] = xjtj[k];
/* L550: */
        }
        ical1i = iscal1 + i__;
        work[k] = onep5 * (xjtj[k] + al * erl2 * work[ical1i]) + rel;
/* L560: */
    }
    ibad = 2;
    goto L310;
L570:
    izero = 0;
    i__1 = iscalu;
    for (j = iscall; j <= i__1; ++j) {
        if (work[j] > zero) {
            goto L580;
        }
        ++izero;
        work[j] = one;
L580:
        ;
    }
    if (izero < *n) {
        goto L280;
    }
    *ier = 38;
    goto L640;
L590:
    ++(*ier);
L600:
    ++(*ier);
L610:
    ++(*ier);
L620:
    ++(*ier);
L630:
    *ier += 129;
    if (*ier == 130) {
        goto L690;
    }
L640:
    work[1] = erl2 + erl2;
    work[2] = (real) ieval;
    *ssq = ssqold;
    g = sig;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        ielx1j = idelx1 + j;
        xhold = (r__1 = work[ielx1j], abs(r__1));
        if (xhold <= zero) {
            goto L650;
        }
/* Computing MIN */
/* Computing MAX */
        r__5 = ax, r__6 = (r__1 = x[j], abs(r__1));
        r__4 = xhold / max(r__5,r__6);
        r__2 = g, r__3 = -(real)r_lg10(&r__4);
        g = min(r__2,r__3);
L650:
        ;
    }
    work[3] = g;
    work[4] = al;
    work[5] = (real) iter;
    if (*ixjac == *m) {
        goto L680;
    }
    li = *n - 1;
    k = li * *m;
    ir = li * *ixjac;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        if (j == *n) {
            goto L670;
        }
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            iri = ir + i__;
            ki = k + i__;
            xjac[iri] = xjac[ki];
/* L660: */
        }
        k -= *m;
        ir -= *ixjac;
L670:
        ;
    }
L680:
    if (*ier == 0) {
        goto L700;
    }
L690:
L700:
    return 0;
} /* mnavr_c */
